﻿using System;
using System.Linq;
using System.Windows;
using Microsoft.Phone.Controls;
using Telerik.Windows.Controls;

namespace TelerikWP7TapJoy.Demos
{
    public partial class TrialFunctionality : PhoneApplicationPage
    {
        RadTrialFeatureReminder featureReminder;

        int FreeTapsCount; //Number of times they can tap the click button without displaying a warning!
        int FeatureUsages; //Counts the number of time they have used the feature. 

        public TrialFunctionality()
        {
            InitializeComponent();

            this.InitExample(); //Sets up our RadTrialFeatureReminder
        }

        private void InitExample()
        {

            button.IsEnabled = true;
            button.Content = "tap here";

            tryAgain.Visibility = Visibility.Collapsed;


            this.FreeTapsCount = 1; //Number of times they can tap the click button without displaying a warning!
            this.FeatureUsages = 3; //Counts the number of time they have used the feature. 

            this.featureReminder = new RadTrialFeatureReminder();
            this.featureReminder.FeatureId = 1; //Can be Unique FeatureID
            this.featureReminder.SimulateTrialForTests = true; 
            this.featureReminder.UsageCount = 0; //Resets Usage Count on Load
            this.featureReminder.AllowedTrialUsageCount = FeatureUsages; //Gets or Sets the Number of Application Runs
            this.featureReminder.OccurrenceUsageCount = 1; //Gets or Sets the Number of App Runs between reminder occurances. 
            this.featureReminder.FreeUsageCount = FreeTapsCount; //Gets or sets the Number of Usages before the first reminder is displayed.
        }

        private void ChangeToExpiredState()
        {
            this.button.IsEnabled = false;
            this.button.Content = "expired";

            this.tryAgain.Visibility = Visibility.Visible;
        }

        private void TapHere(object sender, RoutedEventArgs e)
        {
            this.featureReminder.UsageCount++; //Counts the number of time they have used the feature. 
            if (this.FreeTapsCount > 0) //Number of times they can tap the click button without displaying a warning!
            {
                this.FreeTapsCount--;
            }

            this.featureReminder.Notify();

            if (this.FeatureUsages > 0) //Enable Expired States when the have used all of the usages. 
            {
                this.FeatureUsages--;
            }

            if (this.FeatureUsages <= 0)
            {
                this.ChangeToExpiredState();
            }
        }

        private void TryAgain(object sender, RoutedEventArgs e)
        {
            this.InitExample();
        }   
    }
}